// SrvrItem.cpp : implementation of the COServerSrvrItem class
//

#include "stdafx.h"
#include "OServer.h"

#include "OServerDoc.h"
#include "SrvrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COServerSrvrItem implementation

IMPLEMENT_DYNAMIC(COServerSrvrItem, COleServerItem)

COServerSrvrItem::COServerSrvrItem(COServerDoc* pContainerDoc)
	: COleServerItem(pContainerDoc, TRUE)
{
	// TODO: add one-time construction code here
	//  (eg, adding additional clipboard formats to the item's data source)
}

COServerSrvrItem::~COServerSrvrItem()
{
	// TODO: add cleanup code here
}

void COServerSrvrItem::Serialize(CArchive& ar)
{
	// COServerSrvrItem::Serialize will be called by the framework if
	//  the item is copied to the clipboard.  This can happen automatically
	//  through the OLE callback OnGetClipboardData.  A good default for
	//  the embedded item is simply to delegate to the document's Serialize
	//  function.  If you support links, then you will want to serialize
	//  just a portion of the document.

	if (!IsLinkedItem())
	{
		COServerDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pDoc->Serialize(ar);
	}
}

BOOL COServerSrvrItem::OnGetExtent(DVASPECT dwDrawAspect, CSize& rSize)
{
	// Most applications, like this one, only handle drawing the content
	//  aspect of the item.  If you wish to support other aspects, such
	//  as DVASPECT_THUMBNAIL (by overriding OnDrawEx), then this
	//  implementation of OnGetExtent should be modified to handle the
	//  additional aspect(s).

	if (dwDrawAspect != DVASPECT_CONTENT)
		return COleServerItem::OnGetExtent(dwDrawAspect, rSize);

	// COServerSrvrItem::OnGetExtent is called to get the extent in
	//  HIMETRIC units of the entire item.  The default implementation
	//  here simply returns a hard-coded number of units.

	COServerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: replace this arbitrary size

	rSize = CSize(3000, 3000);   // 3000 x 3000 HIMETRIC units

	return TRUE;
}

BOOL COServerSrvrItem::OnDraw(CDC* pDC, CSize& rSize)
{
	const CString kMessage = "Using Visual C++ 4.0, Special Edition";
	COServerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetWindowOrg(0,0);
	pDC->SetWindowExt(3000, 3000);
	
	pDC->TextOut(0, 0, kMessage, kMessage.GetLength());

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// COServerSrvrItem diagnostics

#ifdef _DEBUG
void COServerSrvrItem::AssertValid() const
{
	COleServerItem::AssertValid();
}

void COServerSrvrItem::Dump(CDumpContext& dc) const
{
	COleServerItem::Dump(dc);
}
#endif

/////////////////////////////////////////////////////////////////////////////
